//+------------------------------------------------------------------+
//|                                                 Test problem XOR |
//+------------------------------------------------------------------+
#include "class_NetRBF.mqh"
//+------------------------------------------------------------------+
//      " "
//  :
//      -1  1
double inppth[]={1,1,1,-1,-1,1,-1,-1}; //    
double tchth[]={-1,1,1,-1};            //    
//      0  1
double inpps[]={1,1,1,0,0,1,0,0};      //    
double tchs[]={0,1,1,0};               //    
//+------------------------------------------------------------------+
void OnStart()
  {
   CNetRBF *net;
   double ivect[2];     //  
   double out[1];       //    
   int epoch=1000;
   //---
   Print("      -1  1");
   //  
   net=new CNetRBF(2,2,1);
   //  
   net.Learn(4,inppth,tchth,epoch,1.0e-8);
   Print("MSE=",net.mse,"  Epoch=",net.epoch," Neurons=",net.neurons);
   //  
   for(int i=0,j=0; i<4; i++)
     {
      ivect[0]=inppth[j++]; ivect[1]=inppth[j++];
      net.Calculate(ivect,out);
      Print("=",(string)ivect[0],", ",(string)ivect[1]," =",DoubleToString(out[0],0)," =",(string)tchth[i]);
     }
   //  
   delete net;
   //---
   Print("      0  1");
   net=new CNetRBF(2,2,1);
   net.Learn(4,inpps,tchs,epoch,1.0e-8);
   Print("MSE=",net.mse,"  Epoch=",net.epoch," Neurons=",net.neurons);
   //       
   int h=FileOpen("primer.net",FILE_BIN|FILE_WRITE);
   net.Save(h);
   FileClose(h);
   delete net;
   //        
   net=new CNetRBF(2,2,1);
   h=FileOpen("primer.net",FILE_BIN|FILE_READ);
   net.Load(h);
   FileClose(h);
   //  
   for(int i=0,j=0; i<4; i++)
     {
      ivect[0]=inpps[j++]; ivect[1]=inpps[j++];
      net.Calculate(ivect,out);
      Print("=",(string)ivect[0],", ",(string)ivect[1]," =",DoubleToString(out[0],0)," =",(string)tchs[i]);
     }
   //  
   delete net;
   FileDelete("primer.net");
  }
//+------------------------------------------------------------------+
